/*
   Name:            Atheon_Client_v1.1
   Author:          zepplin
   Description:     client/server program
   Date Begun:      Friday, Mar. 7, 2003
   Last Updated:    Wednesday, Jan. 28, 2004
   Version:         1.1
*/

#include <windows.h>
#include <fstream.h>
#include <string.h>
#include <winsock.h>
#include <stdio.h>
#include <time.h>

typedef int socklen_t;

#include <iostream.h>
#include <stdlib.h>
#include "client_help.h"

void shutdown();

int login_client();
void restart_client();
int start_client();

hostent* h;
struct sockaddr_in addr;
SOCKET   s1;
int r;

#define NIP 4

int connected=0;
int repeat=1;
int rotation=0;
char host[16];
char TIP[NIP][16]={"22.44.62.1", "22.44.62.230", "192.168.1.1", "192.168.1.122"};
int OIPF=0;
int port=12002;
int login=0;

int main() {
	WSADATA wsa_data;
	WSAStartup(MAKEWORD(1,1), &wsa_data);
    do {
    rotation++;
    login_client();
    if(login==1) {
    start_client();
    restart_client();
    }
    }while (repeat==1);
   	WSACleanup();
   	return 0;
}

int login_client() {
    if(rotation==1){
    cout<<"Server IP: ";
    cin.get(host, 16);
    cin.ignore(80, '\n');
    }
    if(OIPF!=0||OIPF>NIP) {
    host=TIP[OIPF];
    OIPF++;
    cout<<"Attempting connection to new server: "<<host<<endl;
    }
    if(OIPF==NIP) {
    login=0;
    repeat=0;
    connected=0;
    return 0;
    }
    memset((void*)&addr, 0, sizeof(addr));
    addr.sin_addr.s_addr = inet_addr(host);
    if(INADDR_NONE == addr.sin_addr.s_addr) {
        h = gethostbyname(host);
        if(NULL == h) {
            cout<<"gethostbyname Error: Winsock Error# "<<WSAGetLastError()<<endl;
            OIPF++;
            login=0;
            return -1;
        }
         addr.sin_addr = *((in_addr*)*h->h_addr_list);
    }

    s1 = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(INVALID_SOCKET == s1) {
        cout<<"Could not create socket: "<<WSAGetLastError()<<endl;
        OIPF++;
        login=0;
        return -1;
    }

    addr.sin_family = AF_INET;
    addr.sin_port   = htons(port);

    r = connect(s1, (sockaddr*)&addr, sizeof(struct sockaddr));
    if(SOCKET_ERROR == r) {
        cout<<"Cannot connect to server: "<<WSAGetLastError()<<endl;
        closesocket(s1);
        OIPF++;
        login=0;
        return -1;
    }
    login=1;

}

int start_client()
{
    char name[]="Atheon_Client_v1.0";
    char log_o[]="-!-logging out-!-\0";
    char recieved1[1024];
    char data[1000];

    switch(connected) {
    case 0: send(s1, name, strlen(name), 0);
            connected=1;
            break;
    case 1: cout<<">";
            cin.get(data, 1000);
            cin.ignore(80, '\n');
            if(strcmp(data, "logout") == 0) {
            send(s1, log_o, strlen(log_o), 0);
            connected=0;
            repeat=0;
            return 0;
            }
            else if(strcmp(data, "help") == 0) {
            help();
            return 0;
            }
            else send(s1, data, strlen(data), 0); connected=1;
            break;
    }

    if(connected == 1) {
    cout<<"Please wait for server to respond."<<endl;
    memset((void*)recieved1, 0, sizeof(recieved1));
    recv(s1, recieved1, sizeof(recieved1), 0);

    if(strcmp(recieved1, "-!-logging out-!-") == 0) {
    cout<<"Server has shut down or crashed.  Connection lost.  Please reconnect."<<endl;
    connected=0;
    repeat=0;
    return 0;
    }
    else connected=1;

    printf("Server: %s\n", recieved1);
    }
    return 0;
}

void restart_client() {
    closesocket(s1);
}
